﻿Option Strict On
Imports Windows.Storage.Pickers
Imports Windows.Graphics.Imaging
Imports Windows.Storage.Streams
Imports System.Runtime.InteropServices.WindowsRuntime
Imports Windows.Storage
Imports Windows.UI
Imports Windows.UI.Popups

Public NotInheritable Class MainPage
    Inherits Page
    Dim myBilt1 As WriteableBitmap
    Dim wb1 As WriteableBitmap
    Dim myFile2 As StorageFile
    Dim myFile As StorageFile
    Protected Overrides Sub OnNavigatedTo(e As Navigation.NavigationEventArgs)

    End Sub

    Private Async Sub readButton1_Click(sender As Object, e As RoutedEventArgs) Handles readButton1.Click
        Image3.Source = Nothing
        Dim myFileOpenPicker As New FileOpenPicker
        myFileOpenPicker.ViewMode = PickerViewMode.Thumbnail
        myFileOpenPicker.SuggestedStartLocation = PickerLocationId.PicturesLibrary
        myFileOpenPicker.FileTypeFilter.Add("*")
        myFile = Await myFileOpenPicker.PickSingleFileAsync()
        If myFile Is Nothing = False Then
            Dim myBmp As New BitmapImage
            myBmp.SetSource(Await myFile.OpenReadAsync)
            Image1.Source = myBmp
        End If
        readButton2.IsEnabled = True
    End Sub

    Private Async Sub readButton2_Click(sender As Object, e As RoutedEventArgs) Handles readButton2.Click
        Dim myBmp As New BitmapImage

        Dim myFileOpenPicker As New FileOpenPicker
        myFileOpenPicker.ViewMode = PickerViewMode.Thumbnail
        myFileOpenPicker.SuggestedStartLocation = PickerLocationId.PicturesLibrary
        myFileOpenPicker.FileTypeFilter.Add("*")
        myFile2 = Await myFileOpenPicker.PickSingleFileAsync()
        If myFile2 Is Nothing = False Then
            myBmp.SetSource(Await myFile2.OpenReadAsync)
            Image2.Source = myBmp
        End If
        makeButton.IsEnabled = True

    End Sub

    Private Async Sub makeButton_Click(sender As Object, e As RoutedEventArgs) Handles makeButton.Click
        Dim myColor = Colors.White
        wb1 = New WriteableBitmap(CInt(Image1.Width), CInt(Image1.Height))
        Dim wb2 As WriteableBitmap = New WriteableBitmap(CInt(Image2.Width), CInt(Image2.Height))
        myBilt1 = Await wb1.FromStream(Await myFile.OpenReadAsync)
        Dim myBilt2 = Await wb2.FromStream(Await myFile2.OpenReadAsync)
        Dim myRect As New Rect(0, 0, Image1.Width, Image1.Height)
        myBilt1.Blit(myRect, myBilt2, myRect, myColor, WriteableBitmapExtensions.BlendMode.Multiply)
        Image3.Source = myBilt1

        myBilt1.Invalidate()
        saveButton.IsEnabled = True

    End Sub

    Private Async Sub saveButton_Click(sender As Object, e As RoutedEventArgs) Handles saveButton.Click
        '合成画像の保存処理
        Using myStream As Stream = myBilt1.PixelBuffer.AsStream 'ここではまった。単にmyCropを指定すればいいところを、新しいWritableBitmapのインスタンスを作成して指定してしまった。保存される画像は真っ黒になった。

            Await myStream.FlushAsync()

            Dim myPixel As Byte() = New Byte(CInt(myStream.Length - 1)) {}
            Await myStream.ReadAsync(myPixel, 0, myPixel.Length - 1)
            Dim offSet As Integer

            For row As Integer = 0 To CInt(CUInt(myBilt1.PixelHeight) - 1)
                For col As Integer = 0 To CInt(CUInt(myBilt1.PixelWidth) - 1)
                    offSet = CInt((row * CUInt(myBilt1.PixelWidth) * 4) + (col * 4))
                    Dim B As Byte = myPixel(offSet)
                    Dim G As Byte = myPixel(offSet + 1)
                    Dim R As Byte = myPixel(offSet + 2)
                    Dim A As Byte = myPixel(offSet + 3)
                    myPixel(offSet) = R
                    myPixel(offSet + 1) = G
                    myPixel(offSet + 2) = B
                    myPixel(offSet + 3) = A
                Next
            Next

            Dim myFolder As StorageFolder = Windows.Storage.KnownFolders.PicturesLibrary
            Dim SubFolder = Await myFolder.CreateFolderAsync("Texture", CreationCollisionOption.OpenIfExists)
            Dim mySaveFile As StorageFile = Await SubFolder.CreateFileAsync(DateTime.Now.ToString("yyyyMMddHHmmss") & ".png")

            Using myFileStream As IRandomAccessStream = Await mySaveFile.OpenAsync(FileAccessMode.ReadWrite)
                Dim myEncoder As BitmapEncoder = Await BitmapEncoder.CreateAsync(BitmapEncoder.PngEncoderId, myFileStream)
                myEncoder.SetPixelData(BitmapPixelFormat.Rgba8, BitmapAlphaMode.Premultiplied, CUInt(myBilt1.PixelWidth), CUInt(myBilt1.PixelHeight), 96, 96, myPixel)
                Await myEncoder.FlushAsync
            End Using

        End Using

        Dim message As New MessageDialog("保存しました。")
        Await message.ShowAsync
    End Sub
End Class


